package com.trs.util.swf;

import java.io.File;
import java.io.IOException;
import java.net.ConnectException;
import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;

import com.artofsolving.jodconverter.DocumentConverter;
import com.artofsolving.jodconverter.DocumentFamily;
import com.artofsolving.jodconverter.DocumentFormat;
import com.artofsolving.jodconverter.openoffice.connection.OpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.connection.SocketOpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.converter.OpenOfficeDocumentConverter;
import com.trs.infra.util.CharsetDetector;

/**
 * 
 * @author Administrator
 * 
 */
public class SWFCreator extends java.lang.Thread {
    private static Logger m_Logger = Logger.getLogger(SWFCreator.class);

    private File m_oSrcFile;// Ҫתļ

    private File m_oPDFFile;// PDFļ

    private String m_sSWFFileName;

    public String m_sServiceHost = "127.0.0.1";

    public int m_nServicePort = 8100;

    public String m_sSWFToollsPath = "C:\\SWFTools\\";

    public SWFCreator(String _sSrcFileName) {
        this.m_oSrcFile = new File(_sSrcFileName);

        // ļԭʼļ洢Ŀ¼һļͬ׺ͬ
        String sPDFFileName = changeFileExt(_sSrcFileName, "pdf");
        this.m_oPDFFile = new File(sPDFFileName);

        m_sSWFFileName = changeFileExt(_sSrcFileName, "swf");
    }

    public boolean toPDF() {
        String sFileExt = extractFileExt(m_oSrcFile.getName());
        if (sFileExt.equalsIgnoreCase("pdf") || m_oPDFFile.exists())
            return true;

        boolean bResult = false;
        long lStartTime = System.currentTimeMillis();

        OpenOfficeConnection connection = new SocketOpenOfficeConnection(
                m_sServiceHost, m_nServicePort);
        try {
            connection.connect();

            // convert
            DocumentConverter converter = new OpenOfficeDocumentConverter(
                    connection);

            // txtļļı뷽ʽȡļ

            if (sFileExt.equalsIgnoreCase("txt")) {
                String sCharset = CharsetDetector.detect(m_oSrcFile
                        .getAbsolutePath());
                DocumentFormat txt = new DocumentFormat("Plain Text",
                        DocumentFamily.TEXT, "text/plain", "txt");
                txt.setImportOption("FilterName", "Text (encoded)");
                txt.setImportOption("FilterOptions", sCharset + ",CRLF");
                txt.setExportFilter(DocumentFamily.TEXT, "Text (encoded)");
                txt.setExportOption(DocumentFamily.TEXT, "FilterOptions",
                        sCharset + ",CRLF");

                DocumentFormat pdf = new DocumentFormat(
                        "Portable Document Format", "application/pdf", "pdf");
                pdf.setExportFilter(DocumentFamily.DRAWING, "draw_pdf_Export");
                pdf.setExportFilter(DocumentFamily.PRESENTATION,
                        "impress_pdf_Export");
                pdf.setExportFilter(DocumentFamily.SPREADSHEET,
                        "calc_pdf_Export");
                pdf.setExportFilter(DocumentFamily.TEXT, "writer_pdf_Export");

                converter.convert(m_oSrcFile, txt, m_oPDFFile, pdf);
            } else {
                converter.convert(m_oSrcFile, m_oPDFFile);
            }

            bResult = true;

        } catch (ConnectException cex) {
            cex.printStackTrace();
        } finally {
            // close the connection
            if (connection != null) {
                connection.disconnect();
                connection = null;
            }
        }

        m_Logger.debug("" + m_oPDFFile.getName() + "ķѣ"
                + (System.currentTimeMillis() - lStartTime) + "");

        return bResult;
    }

    /**
     * עdestPathļָ
     * תswfToolߣһתļвʶַʱͻҪ
     * 
     * @param sourcePath
     * @return
     * @throws IOException
     * @throws Exception
     */
    public synchronized boolean toSWF() throws IOException {

        if (new File(m_sSWFFileName).exists())
            return true;

        // Դļ򷵻
        if (!m_oPDFFile.exists()) {
            m_Logger.info("pdfתswfʧܣԴļ!");
            throw new IOException();
        }

        if (m_sSWFToollsPath.length() > 0
                && m_sSWFToollsPath.charAt(m_sSWFToollsPath.length() - 1) != File.separatorChar) {
            m_sSWFToollsPath += File.separatorChar;
        }

        // ϵͳãͻϵͳִеĲ¿һ̣߳ڴlinuxҲн̣ɨǶУ´λɨתеļҪ
        // m_oPDFFile.setReadable(false);
        synchronized (m_oPDFFile) {
            m_Logger.debug("ʼswftoolsתpdfļ:" + m_sSWFFileName);

            String sSwfToolsDir = m_sSWFToollsPath + "pdf2swf";

            List command = new ArrayList();
            command.add(sSwfToolsDir);// ļȡ
            command.add("-z");
            // command.add("-B");
            // command.add("rfxview.swf");
            command.add("-s");
            command.add("flashversion=9");

            command.add("-s");
            command.add("poly2bitmap");// poly2bitmapĿΪ˷ִֹļͼιļתʱĳûswfļ쳣

            // windowsƽ̨
            // command.add("languagedir=C:/xpdf/chinese-simplified/");
            command.add(m_oPDFFile.getAbsolutePath());
            command.add("-o");
            command.add(m_sSWFFileName);

            // ProcessBuilder processBuilder = new ProcessBuilder();
            // processBuilder.command(command);
            // Process process = processBuilder.start();
            String[] cmdarray = new String[command.size()];
            command.toArray(cmdarray);
            Process process = Runtime.getRuntime().exec(cmdarray);

            InputStreamWatchThread inputWathThread = new InputStreamWatchThread(
                    process);
            inputWathThread.start();
            ErrorInputStreamWatchThread errorInputWathThread = new ErrorInputStreamWatchThread(
                    process);
            errorInputWathThread.start();

            try {
                process.waitFor();// ȴӽ̵Ľӽ̾ϵͳļת½
                inputWathThread.setOver(true);// תֹ꣬ͣĴ
                errorInputWathThread.setOver(true);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        m_Logger.debug("ת");
        return true;
    }

    /**
     * ڷ̲߳ȫģԡҪ߳
     */
    public void run() {
        if (toPDF()) {
            // PDFתɹִSWFת
            try {
                toSWF();
            } catch (Exception e) {
                m_Logger.error("Fail to convert " + m_oSrcFile + " to "
                        + m_sSWFFileName, e);
            }
        }
    }

    public File getInputFile() {
        return m_oSrcFile;
    }

    public void setInputFile(File inputFile) {
        this.m_oSrcFile = inputFile;
    }

    public File getOutputFile() {
        return m_oPDFFile;
    }

    public void setOutputFile(File outputFile) {
        this.m_oPDFFile = outputFile;
    }

    private static String extractFileExt(String _sFileName) {
        int nPos = _sFileName.lastIndexOf('.');
        return (nPos >= 0 ? _sFileName.substring(nPos + 1) : "");
    }

    private static String changeFileExt(String _sFileName, String _sNewExt) {
        int nPos = _sFileName.lastIndexOf('.');
        if (nPos < 0)
            return _sFileName + "." + _sNewExt;

        return _sFileName.substring(0, nPos + 1) + _sNewExt;
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
        SWFCreator tools = new SWFCreator("c:/TRSݹ.ppt");
        tools.start();
    }

}
